Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -176,294 +203,445 @@
     REAL(wp), PARAMETER ::  amoc   = 150.E-3_wp     !< organic carbon (OC)
     REAL(wp), PARAMETER ::  amss   = 58.44E-3_wp    !< sea salt (NaCl)
+!
 !-- Densities in kg/m3
-    REAL(wp), PARAMETER ::  arhobc     = 2000.0_wp !< black carbon
-    REAL(wp), PARAMETER ::  arhodu     = 2650.0_wp !< mineral dust
-    REAL(wp), PARAMETER ::  arhoh2o    = 1000.0_wp !< H2O
-    REAL(wp), PARAMETER ::  arhoh2so4  = 1830.0_wp !< SO4 
-    REAL(wp), PARAMETER ::  arhohno3   = 1479.0_wp !< HNO3
-    REAL(wp), PARAMETER ::  arhonh3    = 1530.0_wp !< NH3 
-    REAL(wp), PARAMETER ::  arhooc     = 2000.0_wp !< organic carbon
-    REAL(wp), PARAMETER ::  arhoss     = 2165.0_wp !< sea salt (NaCl)
+    REAL(wp), PARAMETER ::  arhobc     = 2000.0_wp  !< black carbon
+    REAL(wp), PARAMETER ::  arhodu     = 2650.0_wp  !< mineral dust
+    REAL(wp), PARAMETER ::  arhoh2o    = 1000.0_wp  !< H2O
+    REAL(wp), PARAMETER ::  arhoh2so4  = 1830.0_wp  !< SO4
+    REAL(wp), PARAMETER ::  arhohno3   = 1479.0_wp  !< HNO3
+    REAL(wp), PARAMETER ::  arhonh3    = 1530.0_wp  !< NH3
+    REAL(wp), PARAMETER ::  arhooc     = 2000.0_wp  !< organic carbon
+    REAL(wp), PARAMETER ::  arhoss     = 2165.0_wp  !< sea salt (NaCl)
+!
 !-- Volume of molecule in m3/#
     REAL(wp), PARAMETER ::  amvh2o   = amh2o /avo / arhoh2o      !< H2O
     REAL(wp), PARAMETER ::  amvh2so4 = amh2so4 / avo / arhoh2so4 !< SO4
-    REAL(wp), PARAMETER ::  amvhno3  = amhno3 / avo / arhohno3   !< HNO3 
-    REAL(wp), PARAMETER ::  amvnh3   = amnh3 / avo / arhonh3     !< NH3  
+    REAL(wp), PARAMETER ::  amvhno3  = amhno3 / avo / arhohno3   !< HNO3
+    REAL(wp), PARAMETER ::  amvnh3   = amnh3 / avo / arhonh3     !< NH3
     REAL(wp), PARAMETER ::  amvoc    = amoc / avo / arhooc       !< OC
     REAL(wp), PARAMETER ::  amvss    = amss / avo / arhoss       !< sea salt
-    
+!
+!-- Constants for the dry deposition model by Petroff and Zhang (2010):
+!-- obstacle characteristic dimension "L" (cm) (plane obstacle by default) and empirical constants
+!-- C_B, C_IN, C_IM, beta_IM and C_IT for each land use category (15, as in Zhang et al. (2001))
+    REAL(wp), DIMENSION(1:15), PARAMETER :: l_p10 = &
+        (/0.15, 4.0, 0.15, 3.0, 3.0, 0.5, 3.0, -99., 0.5, 2.0, 1.0, -99., -99., -99., 3.0/)
+    REAL(wp), DIMENSION(1:15), PARAMETER :: c_b_p10 = &
+        (/0.887, 1.262, 0.887, 1.262, 1.262, 0.996, 0.996, -99., 0.7, 0.93, 0.996, -99., -99., -99., 1.262/)
+    REAL(wp), DIMENSION(1:15), PARAMETER :: c_in_p10 = &
+        (/0.81, 0.216, 0.81, 0.216, 0.216, 0.191, 0.162, -99., 0.7, 0.14, 0.162, -99., -99., -99., 0.216/)
+    REAL(wp), DIMENSION(1:15), PARAMETER :: c_im_p10 = &
+        (/0.162, 0.13, 0.162, 0.13, 0.13, 0.191, 0.081, -99., 0.191, 0.086, 0.081, -99., -99., -99., 0.13/)
+    REAL(wp), DIMENSION(1:15), PARAMETER :: beta_im_p10 = &
+        (/0.6, 0.47, 0.6, 0.47, 0.47, 0.47, 0.47, -99., 0.6, 0.47, 0.47, -99., -99., -99., 0.47/)
+    REAL(wp), DIMENSION(1:15), PARAMETER :: c_it_p10 = &
+        (/0.0, 0.056, 0.0, 0.056, 0.056, 0.042, 0.056, -99., 0.042, 0.014, 0.056, -99., -99., -99., 0.056/)
+!
+!-- Constants for the dry deposition model by Zhang et al. (2001): 
+!-- empirical constants "alpha" and "gamma" and characteristic radius "A" for 
+!-- each land use category (15) and season (5)
+    REAL(wp), DIMENSION(1:15), PARAMETER :: alpha_z01 = &
+        (/1.0, 0.6, 1.1, 0.8, 0.8, 1.2, 1.2, 50.0, 50.0, 1.3, 2.0, 50.0, 100.0, 100.0, 1.5/)
+    REAL(wp), DIMENSION(1:15), PARAMETER :: gamma_z01 = &
+        (/0.56, 0.58, 0.56, 0.56, 0.56, 0.54, 0.54, 0.54, 0.54, 0.54, 0.54, 0.54, 0.50, 0.50, 0.56/)
+    REAL(wp), DIMENSION(1:15,1:5), PARAMETER :: A_z01 =  RESHAPE( (/& 
+         2.0, 5.0, 2.0,  5.0, 5.0, 2.0, 2.0, -99., -99., 10.0, 10.0, -99., -99., -99., 10.0,&  ! SC1
+         2.0, 5.0, 2.0,  5.0, 5.0, 2.0, 2.0, -99., -99., 10.0, 10.0, -99., -99., -99., 10.0,&  ! SC2
+         2.0, 5.0, 5.0, 10.0, 5.0, 5.0, 5.0, -99., -99., 10.0, 10.0, -99., -99., -99., 10.0,&  ! SC3
+         2.0, 5.0, 5.0, 10.0, 5.0, 5.0, 5.0, -99., -99., 10.0, 10.0, -99., -99., -99., 10.0,&  ! SC4
+         2.0, 5.0, 2.0,  5.0, 5.0, 2.0, 2.0, -99., -99., 10.0, 10.0, -99., -99., -99., 10.0 &  ! SC5
+                                                           /), (/ 15, 5 /) )
+!-- Land use categories (based on Z01 but the same applies here also for P10):
+!-- 1 = evergreen needleleaf trees,
+!-- 2 = evergreen broadleaf trees,
+!-- 3 = deciduous needleleaf trees,
+!-- 4 = deciduous broadleaf trees,
+!-- 5 = mixed broadleaf and needleleaf trees (deciduous broadleaf trees for P10),
+!-- 6 = grass (short grass for P10),
+!-- 7 = crops, mixed farming,
+!-- 8 = desert,
+!-- 9 = tundra,
+!-- 10 = shrubs and interrupted woodlands (thorn shrubs for P10),
+!-- 11 = wetland with plants (long grass for P10)
+!-- 12 = ice cap and glacier,
+!-- 13 = inland water (inland lake for P10)
+!-- 14 = ocean (water for P10),
+!-- 15 = urban
+!
+!-- SALSA variables:
+    CHARACTER(LEN=20)  ::  bc_salsa_b = 'neumann'                 !< bottom boundary condition
+    CHARACTER(LEN=20)  ::  bc_salsa_t = 'neumann'                 !< top boundary condition
+    CHARACTER(LEN=20)  ::  depo_pcm_par = 'zhang2001'             !< or 'petroff2010'
+    CHARACTER(LEN=20)  ::  depo_pcm_type = 'deciduous_broadleaf'  !< leaf type
+    CHARACTER(LEN=20)  ::  depo_surf_par = 'zhang2001'            !< or 'petroff2010'
+    CHARACTER(LEN=100) ::  input_file_dynamic = 'PIDS_DYNAMIC'    !< file name for dynamic input
+    CHARACTER(LEN=100) ::  input_file_salsa   = 'PIDS_SALSA'      !< file name for emission data
+    CHARACTER(LEN=20)  ::  salsa_emission_mode = 'no_emission'    !< 'no_emission', 'uniform',
+                                                                  !< 'parameterized', 'read_from_file'
+
+    CHARACTER(LEN=20), DIMENSION(4) ::  decycle_method =                                           &
+                                                 (/'dirichlet','dirichlet','dirichlet','dirichlet'/)
+                                     !< Decycling method at horizontal boundaries
+                                     !< 1=left, 2=right, 3=south, 4=north
+                                     !< dirichlet = initial profiles for the ghost and first 3 layers
+                                     !< neumann = zero gradient
+
+    CHARACTER(LEN=3), DIMENSION(maxspec) ::  listspec = &  !< Active aerosols
+                                   (/'SO4','   ','   ','   ','   ','   ','   '/)
+
+    INTEGER(iwp) ::  depo_pcm_type_num = 0  !< index for the dry deposition type on the plant canopy
+    INTEGER(iwp) ::  dots_salsa = 0         !< starting index for salsa-timeseries
+    INTEGER(iwp) ::  end_subrange_1a = 1    !< last index for bin subrange 1a
+    INTEGER(iwp) ::  end_subrange_2a = 1    !< last index for bin subrange 2a
+    INTEGER(iwp) ::  end_subrange_2b = 1    !< last index for bin subrange 2b
+    INTEGER(iwp) ::  ibc_salsa_b            !< index for the bottom boundary condition
+    INTEGER(iwp) ::  ibc_salsa_t            !< index for the top boundary condition
+    INTEGER(iwp) ::  index_bc  = -1         !< index for black carbon (BC)
+    INTEGER(iwp) ::  index_du  = -1         !< index for dust
+    INTEGER(iwp) ::  igctyp = 0             !< Initial gas concentration type
+                                            !< 0 = uniform (read from PARIN)
+                                            !< 1 = read vertical profile from an input file
+    INTEGER(iwp) ::  index_nh  = -1         !< index for NH3
+    INTEGER(iwp) ::  index_no  = -1         !< index for HNO3
+    INTEGER(iwp) ::  index_oc  = -1         !< index for organic carbon (OC)
+    INTEGER(iwp) ::  isdtyp = 0             !< Initial size distribution type
+                                            !< 0 = uniform (read from PARIN)
+                                            !< 1 = read vertical profile of the mode number
+                                            !<     concentration from an input file
+    INTEGER(iwp) ::  index_so4 = -1         !< index for SO4 or H2SO4
+    INTEGER(iwp) ::  index_ss  = -1         !< index for sea salt
+    INTEGER(iwp) ::  lod_gas_emissions = 0  !< level of detail of the gaseous emission data
+    INTEGER(iwp) ::  nbins_aerosol = 1      !< total number of size bins
+    INTEGER(iwp) ::  ncc   = 1              !< number of chemical components used
+    INTEGER(iwp) ::  ncomponents_mass = 1   !< total number of chemical compounds (ncc+1)
+                                            !< if particle water is advected)
+    INTEGER(iwp) ::  nj3 = 1                !< J3 parametrization (nucleation)
+                                            !< 1 = condensational sink (Kerminen&Kulmala, 2002)
+                                            !< 2 = coagulational sink (Lehtinen et al. 2007)
+                                            !< 3 = coagS+self-coagulation (Anttila et al. 2010)
+    INTEGER(iwp) ::  nsnucl = 0             !< Choice of the nucleation scheme:
+                                            !< 0 = off
+                                            !< 1 = binary nucleation
+                                            !< 2 = activation type nucleation
+                                            !< 3 = kinetic nucleation
+                                            !< 4 = ternary nucleation
+                                            !< 5 = nucleation with ORGANICs
+                                            !< 6 = activation type of nucleation with H2SO4+ORG
+                                            !< 7 = heteromolecular nucleation with H2SO4*ORG
+                                            !< 8 = homomolecular nucleation of H2SO4
+                                            !<     + heteromolecular nucleation with H2SO4*ORG
+                                            !< 9 = homomolecular nucleation of H2SO4 and ORG
+                                            !<     + heteromolecular nucleation with H2SO4*ORG
+    INTEGER(iwp) ::  start_subrange_1a = 1  !< start index for bin subranges: subrange 1a
+    INTEGER(iwp) ::  start_subrange_2a = 1  !<                                subrange 2a
+    INTEGER(iwp) ::  start_subrange_2b = 1  !<                                subrange 2b
+
+    INTEGER(iwp), DIMENSION(nreg) ::  nbin = (/ 3, 7/)  !< Number of size bins per subrange: 1 & 2
+
+    INTEGER(iwp), DIMENSION(ngases_salsa) ::  gas_index_chem = &
+                                                 (/ 1, 1, 1, 1, 1/)  !< gas indices in chemistry_model_mod
+                                                 !< 1 = H2SO4, 2 = HNO3, 3 = NH3, 4 = OCNV, 5 = OCSV
+    INTEGER(iwp), DIMENSION(ngases_salsa) ::  emission_index_chem  !< gas indices in the gas emission file
+
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  k_topo_top  !< vertical index of the topography top
 !
 !-- SALSA switches:
-    INTEGER(iwp) ::  nj3 = 1 !< J3 parametrization (nucleation)
-                             !< 1 = condensational sink (Kerminen&Kulmala, 2002)
-                             !< 2 = coagulational sink (Lehtinen et al. 2007)
-                             !< 3 = coagS+self-coagulation (Anttila et al. 2010)                                       
-    INTEGER(iwp) ::  nsnucl = 0 !< Choice of the nucleation scheme:
-                                !< 0 = off   
-                                !< 1 = binary nucleation
-                                !< 2 = activation type nucleation
-                                !< 3 = kinetic nucleation
-                                !< 4 = ternary nucleation
-                                !< 5 = nucleation with ORGANICs
-                                !< 6 = activation type of nucleation with 
-                                !<     H2SO4+ORG
-                                !< 7 = heteromolecular nucleation with H2SO4*ORG
-                                !< 8 = homomolecular nucleation of  H2SO4 + 
-                                !<     heteromolecular nucleation with H2SO4*ORG
-                                !< 9 = homomolecular nucleation of  H2SO4 and ORG 
-                                !<     +heteromolecular nucleation with H2SO4*ORG 
-    LOGICAL ::  advect_particle_water = .TRUE.  !< advect water concentration of 
-                                                !< particles                                
-    LOGICAL ::  decycle_lr            = .FALSE. !< Undo cyclic boundary
-                                                !< conditions: left and right
-    LOGICAL ::  decycle_ns            = .FALSE. !< north and south boundaries
-    LOGICAL ::  feedback_to_palm      = .FALSE. !< allow feedback due to 
-                                                !< hydration and/or condensation
-                                                !< of H20
-    LOGICAL ::  no_insoluble          = .FALSE. !< Switch to exclude insoluble  
-                                                !< chemical components 
-    LOGICAL ::  read_restart_data_salsa = .FALSE. !< read restart data for salsa
-    LOGICAL ::  salsa_gases_from_chem = .FALSE.   !< Transfer the gaseous 
-                                                  !< components to SALSA from  
-                                                  !< from chemistry model
-    LOGICAL ::  van_der_waals_coagc   = .FALSE.   !< Enhancement of coagulation 
-                                                  !< kernel by van der Waals and
-                                                  !< viscous forces
-    LOGICAL ::  write_binary_salsa    = .FALSE.   !< read binary for salsa
+    LOGICAL ::  advect_particle_water = .TRUE.     !< advect water concentration of particles
+    LOGICAL ::  decycle_lr            = .FALSE.    !< Undo cyclic boundary conditions: left and right
+    LOGICAL ::  decycle_ns            = .FALSE.    !< north and south boundaries
+    LOGICAL ::  feedback_to_palm      = .FALSE.    !< allow feedback due to condensation of H2O
+    LOGICAL ::  nest_salsa            = .FALSE.    !< apply nesting for salsa
+    LOGICAL ::  no_insoluble          = .FALSE.    !< Switch to exclude insoluble chemical components
+    LOGICAL ::  read_restart_data_salsa = .FALSE.  !< read restart data for salsa
+    LOGICAL ::  salsa_gases_from_chem = .FALSE.    !< Transfer the gaseous components to SALSA from
+                                                   !< from chemistry model
+    LOGICAL ::  van_der_waals_coagc   = .FALSE.    !< Enhancement of coagulation kernel by van der
+                                                   !< Waals and viscous forces
+    LOGICAL ::  write_binary_salsa    = .FALSE.    !< read binary for salsa
+!
 !-- Process switches: nl* is read from the NAMELIST and is NOT changed.
-!--                   ls* is the switch used and will get the value of nl* 
+!--                   ls* is the switch used and will get the value of nl*
 !--                       except for special circumstances (spinup period etc.)
-    LOGICAL ::  nlcoag       = .FALSE. !< Coagulation master switch
-    LOGICAL ::  lscoag       = .FALSE. !<
-    LOGICAL ::  nlcnd        = .FALSE. !< Condensation master switch
-    LOGICAL ::  lscnd        = .FALSE. !<
-    LOGICAL ::  nlcndgas     = .FALSE. !< Condensation of precursor gases
-    LOGICAL ::  lscndgas     = .FALSE. !<
-    LOGICAL ::  nlcndh2oae   = .FALSE. !< Condensation of H2O on aerosol
-    LOGICAL ::  lscndh2oae   = .FALSE. !< particles (FALSE -> equilibrium calc.)
-    LOGICAL ::  nldepo       = .FALSE. !< Deposition master switch
-    LOGICAL ::  lsdepo       = .FALSE. !< 
-    LOGICAL ::  nldepo_topo  = .FALSE. !< Deposition on vegetation master switch
-    LOGICAL ::  lsdepo_topo  = .FALSE. !< 
-    LOGICAL ::  nldepo_vege  = .FALSE. !< Deposition on walls master switch
-    LOGICAL ::  lsdepo_vege  = .FALSE. !< 
-    LOGICAL ::  nldistupdate = .TRUE.  !< Size distribution update master switch                                      
-    LOGICAL ::  lsdistupdate = .FALSE. !<                                     
-!
-!-- SALSA variables:
-    CHARACTER (LEN=20) ::  bc_salsa_b = 'neumann'   !< bottom boundary condition                                      
-    CHARACTER (LEN=20) ::  bc_salsa_t = 'neumann'   !< top boundary condition 
-    CHARACTER (LEN=20) ::  depo_vege_type = 'zhang2001' !< or 'petroff2010' 
-    CHARACTER (LEN=20) ::  depo_topo_type = 'zhang2001' !< or 'petroff2010' 
-    CHARACTER (LEN=20), DIMENSION(4) ::  decycle_method = & 
-                             (/'dirichlet','dirichlet','dirichlet','dirichlet'/)
-                                 !< Decycling method at horizontal boundaries, 
-                                 !< 1=left, 2=right, 3=south, 4=north
-                                 !< dirichlet = initial size distribution and 
-                                 !< chemical composition set for the ghost and 
-                                 !< first three layers
-                                 !< neumann = zero gradient
-    CHARACTER (LEN=3), DIMENSION(maxspec) ::  listspec = &  !< Active aerosols
-                                   (/'SO4','   ','   ','   ','   ','   ','   '/)
-    CHARACTER (LEN=20) ::  salsa_source_mode = 'no_source' 
-                                                    !< 'read_from_file',
-                                                    !< 'constant' or 'no_source'                                   
-    INTEGER(iwp) ::  dots_salsa = 0  !< starting index for salsa-timeseries
-    INTEGER(iwp) ::  fn1a = 1    !< last index for bin subranges:  subrange 1a
-    INTEGER(iwp) ::  fn2a = 1    !<                              subrange 2a
-    INTEGER(iwp) ::  fn2b = 1    !<                              subrange 2b
-    INTEGER(iwp), DIMENSION(ngast) ::  gas_index_chem = (/ 1, 1, 1, 1, 1/) !<
-                                 !< Index of gaseous compounds in the chemistry 
-                                 !< model. In SALSA, 1 = H2SO4, 2 = HNO3, 
-                                 !< 3 = NH3, 4 = OCNV, 5 = OCSV
-    INTEGER(iwp) ::  ibc_salsa_b !<
-    INTEGER(iwp) ::  ibc_salsa_t !<
-    INTEGER(iwp) ::  igctyp = 0  !< Initial gas concentration type
-                                 !< 0 = uniform (use H2SO4_init, HNO3_init, 
-                                 !<     NH3_init, OCNV_init and OCSV_init)
-                                 !< 1 = read vertical profile from an input file  
-    INTEGER(iwp) ::  in1a = 1    !< start index for bin subranges: subrange 1a
-    INTEGER(iwp) ::  in2a = 1    !<                              subrange 2a
-    INTEGER(iwp) ::  in2b = 1    !<                              subrange 2b 
-    INTEGER(iwp) ::  isdtyp = 0  !< Initial size distribution type
-                                 !< 0 = uniform
-                                 !< 1 = read vertical profile of the mode number
-                                 !<     concentration from an input file  
-    INTEGER(iwp) ::  ibc  = -1 !< Indice for: black carbon (BC)
-    INTEGER(iwp) ::  idu  = -1 !< dust
-    INTEGER(iwp) ::  inh  = -1 !< NH3 
-    INTEGER(iwp) ::  ino  = -1 !< HNO3   
-    INTEGER(iwp) ::  ioc  = -1 !< organic carbon (OC)
-    INTEGER(iwp) ::  iso4 = -1 !< SO4 or H2SO4   
-    INTEGER(iwp) ::  iss  = -1 !< sea salt
-    INTEGER(iwp) ::  lod_aero = 0   !< level of detail for aerosol emissions
-    INTEGER(iwp) ::  lod_gases = 0  !< level of detail for gaseous emissions    
-    INTEGER(iwp), DIMENSION(nreg) ::  nbin = (/ 3, 7/)    !< Number of size bins
-                                               !< for each aerosol size subrange
-    INTEGER(iwp) ::  nbins = 1  !< total number of size bins
-    INTEGER(iwp) ::  ncc   = 1  !< number of chemical components used      
-    INTEGER(iwp) ::  ncc_tot = 1!< total number of chemical compounds (ncc+1 
-                                !< if particle water is advected)
-    REAL(wp) ::  act_coeff = 1.0E-7_wp     !< Activation coefficient
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::  emission_mass_fracs  !< array for 
-                                    !< aerosol composition per emission category
-                                    !< 1:SO4 2:OC 3:BC 4:DU 5:SS 6:NO 7:NH  
-    REAL(wp) ::  dt_salsa  = 0.00001_wp    !< Time step of SALSA
-    REAL(wp) ::  H2SO4_init = nclim        !< Init value for sulphuric acid gas
-    REAL(wp) ::  HNO3_init  = nclim        !< Init value for nitric acid gas
-    REAL(wp) ::  last_salsa_time = 0.0_wp  !< time of the previous salsa 
-                                           !< timestep
-    REAL(wp) ::  nf2a = 1.0_wp             !< Number fraction allocated to a-
-                                           !< bins in subrange 2
-                                           !< (b-bins will get 1-nf2a)   
-    REAL(wp) ::  NH3_init  = nclim         !< Init value for ammonia gas
-    REAL(wp) ::  OCNV_init = nclim         !< Init value for non-volatile 
-                                           !< organic gases
-    REAL(wp) ::  OCSV_init = nclim         !< Init value for semi-volatile 
-                                           !< organic gases
+    LOGICAL ::  nlcoag       = .FALSE.  !< Coagulation master switch
+    LOGICAL ::  lscoag       = .FALSE.  !<
+    LOGICAL ::  nlcnd        = .FALSE.  !< Condensation master switch
+    LOGICAL ::  lscnd        = .FALSE.  !<
+    LOGICAL ::  nlcndgas     = .FALSE.  !< Condensation of precursor gases
+    LOGICAL ::  lscndgas     = .FALSE.  !<
+    LOGICAL ::  nlcndh2oae   = .FALSE.  !< Condensation of H2O on aerosol
+    LOGICAL ::  lscndh2oae   = .FALSE.  !< particles (FALSE -> equilibrium calc.)
+    LOGICAL ::  nldepo       = .FALSE.  !< Deposition master switch
+    LOGICAL ::  lsdepo       = .FALSE.  !<
+    LOGICAL ::  nldepo_surf  = .FALSE.  !< Deposition on vegetation master switch
+    LOGICAL ::  lsdepo_surf  = .FALSE.  !<
+    LOGICAL ::  nldepo_pcm   = .FALSE.  !< Deposition on walls master switch
+    LOGICAL ::  lsdepo_pcm   = .FALSE.  !<
+    LOGICAL ::  nldistupdate = .TRUE.   !< Size distribution update master switch
+    LOGICAL ::  lsdistupdate = .FALSE.  !<
+    LOGICAL ::  lspartition  = .FALSE.  !< Partition of HNO3 and NH3
+
+    REAL(wp) ::  act_coeff = 1.0E-7_wp               !< Activation coefficient
+    REAL(wp) ::  dt_salsa  = 0.00001_wp              !< Time step of SALSA
+    REAL(wp) ::  h2so4_init = nclim                  !< Init value for sulphuric acid gas
+    REAL(wp) ::  hno3_init  = nclim                  !< Init value for nitric acid gas
+    REAL(wp) ::  last_salsa_time = 0.0_wp            !< previous salsa call
+    REAL(wp) ::  next_aero_emission_update = 0.0_wp  !< previous emission update
+    REAL(wp) ::  next_gas_emission_update = 0.0_wp   !< previous emission update
+    REAL(wp) ::  nf2a = 1.0_wp                       !< Number fraction allocated to 2a-bins
+    REAL(wp) ::  nh3_init  = nclim                   !< Init value for ammonia gas
+    REAL(wp) ::  ocnv_init = nclim                   !< Init value for non-volatile organic gases
+    REAL(wp) ::  ocsv_init = nclim                   !< Init value for semi-volatile organic gases
+    REAL(wp) ::  rhlim = 1.20_wp                     !< RH limit in %/100. Prevents unrealistical RH
+    REAL(wp) ::  skip_time_do_salsa = 0.0_wp         !< Starting time of SALSA (s)
+!
+!-- Initial log-normal size distribution: mode diameter (dpg, metres),
+!-- standard deviation (sigmag) and concentration (n_lognorm, #/m3)
+    REAL(wp), DIMENSION(nmod) ::  dpg   = &
+                                     (/0.013_wp, 0.054_wp, 0.86_wp, 0.2_wp, 0.2_wp, 0.2_wp, 0.2_wp/)
+    REAL(wp), DIMENSION(nmod) ::  sigmag  = &
+                                        (/1.8_wp, 2.16_wp, 2.21_wp, 2.0_wp, 2.0_wp, 2.0_wp, 2.0_wp/)
+    REAL(wp), DIMENSION(nmod) ::  n_lognorm = &
+                             (/1.04e+11_wp, 3.23E+10_wp, 5.4E+6_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp/)
+!
+!-- Initial mass fractions / chemical composition of the size distribution
+    REAL(wp), DIMENSION(maxspec) ::  mass_fracs_a = & !< mass fractions between
+             (/1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0/) !< aerosol species for A bins
+    REAL(wp), DIMENSION(maxspec) ::  mass_fracs_b = & !< mass fractions between
+             (/0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0/) !< aerosol species for B bins
     REAL(wp), DIMENSION(nreg+1) ::  reglim = & !< Min&max diameters of size subranges
                                  (/ 3.0E-9_wp, 5.0E-8_wp, 1.0E-5_wp/)
-    REAL(wp) ::  rhlim = 1.20_wp    !< RH limit in %/100. Prevents 
-                                    !< unrealistically high RH in condensation                            
-    REAL(wp) ::  skip_time_do_salsa = 0.0_wp !< Starting time of SALSA (s) 
-!-- Initial log-normal size distribution: mode diameter (dpg, micrometres), 
-!-- standard deviation (sigmag) and concentration (n_lognorm, #/cm3)
-    REAL(wp), DIMENSION(nmod) ::  dpg   = (/0.013_wp, 0.054_wp, 0.86_wp,       &
-                                            0.2_wp, 0.2_wp, 0.2_wp, 0.2_wp/) 
-    REAL(wp), DIMENSION(nmod) ::  sigmag  = (/1.8_wp, 2.16_wp, 2.21_wp,        &
-                                              2.0_wp, 2.0_wp, 2.0_wp, 2.0_wp/)  
-    REAL(wp), DIMENSION(nmod) ::  n_lognorm = (/1.04e+5_wp, 3.23E+4_wp, 5.4_wp,&
-                                                0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp/)
-!-- Initial mass fractions / chemical composition of the size distribution    
-    REAL(wp), DIMENSION(maxspec) ::  mass_fracs_a = & !< mass fractions between 
-             (/1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0/) !< aerosol species for A bins
-    REAL(wp), DIMENSION(maxspec) ::  mass_fracs_b = & !< mass fractions between 
-             (/0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0/) !< aerosol species for B bins
-             
-    REAL(wp), ALLOCATABLE, DIMENSION(:) ::  bin_low_limits  !< to deliver 
-                                                            !< information about 
-                                                            !< the lower 
-                                                            !< diameters per bin                                        
-    REAL(wp), ALLOCATABLE, DIMENSION(:) ::  nsect     !< Background number 
-                                                      !< concentration per bin
-    REAL(wp), ALLOCATABLE, DIMENSION(:) ::  massacc   !< Mass accomodation 
-                                                      !< coefficients per bin                                              
-!
-!-- SALSA derived datatypes: 
-!
-!-- Prognostic variable: Aerosol size bin information (number (#/m3) and 
-!-- mass (kg/m3) concentration) and the concentration of gaseous tracers (#/m3).
-!-- Gas tracers are contained sequentially in dimension 4 as: 
-!-- 1. H2SO4, 2. HNO3, 3. NH3, 4. OCNV (non-volatile organics), 
-!-- 5. OCSV (semi-volatile)
+!
+!-- Initial log-normal size distribution: mode diameter (dpg, metres), standard deviation (sigmag)
+!-- concentration (n_lognorm, #/m3) and mass fractions of all chemical components (listed in
+!-- listspec) for both a (soluble) and b (insoluble) bins.
+    REAL(wp), DIMENSION(nmod) ::  aerosol_flux_dpg   = &
+                                     (/0.013_wp, 0.054_wp, 0.86_wp, 0.2_wp, 0.2_wp, 0.2_wp, 0.2_wp/)
+    REAL(wp), DIMENSION(nmod) ::  aerosol_flux_sigmag  = &
+                                        (/1.8_wp, 2.16_wp, 2.21_wp, 2.0_wp, 2.0_wp, 2.0_wp, 2.0_wp/)
+    REAL(wp), DIMENSION(nmod) ::  surface_aerosol_flux = &
+                             (/1.04e+11_wp, 3.23E+10_wp, 5.4E+6_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp/)
+    REAL(wp), DIMENSION(maxspec) ::  aerosol_flux_mass_fracs_a = &
+                                                               (/1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0/)
+    REAL(wp), DIMENSION(maxspec) ::  aerosol_flux_mass_fracs_b = &
+                                                               (/0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0/)
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  bin_low_limits     !< to deliver information about
+                                                               !< the lower diameters per bin
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  bc_am_t_val        !< vertical gradient of: aerosol mass
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  bc_an_t_val        !< of: aerosol number
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  bc_gt_t_val        !< salsa gases near domain top
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  gas_emission_time  !< Time array in gas emission data (s)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  nsect              !< Background number concentrations
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  massacc            !< Mass accomodation coefficients
+!
+!-- SALSA derived datatypes:
+!
+!-- For matching LSM and the deposition module surface types
+    TYPE match_lsm_depo
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  match
+    END TYPE match_lsm_depo
+!
+!-- Aerosol emission data attributes
+    TYPE salsa_emission_attribute_type
+
+       CHARACTER(LEN=25) ::   units
+
+       CHARACTER(LEN=25), DIMENSION(:), ALLOCATABLE ::   cat_name    !<
+       CHARACTER(LEN=25), DIMENSION(:), ALLOCATABLE ::   cc_name     !<
+       CHARACTER(LEN=25), DIMENSION(:), ALLOCATABLE ::   unit_time   !<
+       CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names   !<
+
+       INTEGER(iwp) ::  lod = 0            !< level of detail
+       INTEGER(iwp) ::  nbins = 10         !< number of aerosol size bins
+       INTEGER(iwp) ::  ncat  = 0          !< number of emission categories
+       INTEGER(iwp) ::  ncc   = 7          !< number of aerosol chemical components
+       INTEGER(iwp) ::  nhoursyear = 0     !< number of hours: HOURLY mode
+       INTEGER(iwp) ::  nmonthdayhour = 0  !< number of month days and hours: MDH mode
+       INTEGER(iwp) ::  num_vars           !< number of variables
+       INTEGER(iwp) ::  nt  = 0            !< number of time steps
+       INTEGER(iwp) ::  nz  = 0            !< number of vertical levels
+       INTEGER(iwp) ::  tind               !< time index for reference time in salsa emission data
+
+       INTEGER(iwp), DIMENSION(maxspec) ::  cc_input_to_model   !<
+
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  cat_index  !< Index of emission categories
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  cc_index   !< Index of chemical components
+
+       REAL(wp) ::  conversion_factor  !< unit conversion factor for aerosol emissions
+
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  dmid         !< mean diameters of size bins (m)
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  rho          !< average density (kg/m3)
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  time         !< time (s)
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  time_factor  !< emission time factor
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  z            !< height (m)
+
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  etf  !< emission time factor
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE :: stack_height
+
+    END TYPE salsa_emission_attribute_type
+!
+!-- The default size distribution and mass composition per emission category:
+!-- 1 = traffic, 2 = road dust, 3 = wood combustion, 4 = other
+!-- Mass fractions: H2SO4, OC, BC, DU, SS, HNO3, NH3
+    TYPE salsa_emission_mode_type
+
+       INTEGER(iwp) ::  ndm = 3  !< number of default modes
+       INTEGER(iwp) ::  ndc = 4  !< number of default categories
+
+       CHARACTER(LEN=25), DIMENSION(1:4) ::  cat_name_table = (/'traffic exhaust', &
+                                                                'road dust      ', &
+                                                                'wood combustion', &
+                                                                'other          '/)
+
+       INTEGER(iwp), DIMENSION(1:4) ::  cat_input_to_model   !<
+
+       REAL(wp), DIMENSION(1:3) ::  dpg_table = (/ 13.5E-9_wp, 1.4E-6_wp, 5.4E-8_wp/)  !<
+       REAL(wp), DIMENSION(1:3) ::  ntot_table  !<
+       REAL(wp), DIMENSION(1:3) ::  sigmag_table = (/ 1.6_wp, 1.4_wp, 1.7_wp /)  !<
+
+       REAL(wp), DIMENSION(1:maxspec,1:4) ::  mass_frac_table = &  !<
+          RESHAPE( (/ 0.04_wp, 0.48_wp, 0.48_wp, 0.0_wp,  0.0_wp, 0.0_wp, 0.0_wp, &
+                      0.0_wp,  0.05_wp, 0.0_wp,  0.95_wp, 0.0_wp, 0.0_wp, 0.0_wp, &
+                      0.0_wp,  0.5_wp,  0.5_wp,  0.0_wp,  0.0_wp, 0.0_wp, 0.0_wp, &
+                      0.0_wp,  0.5_wp,  0.5_wp,  0.0_wp,  0.0_wp, 0.0_wp, 0.0_wp  &
+                   /), (/maxspec,4/) )
+
+       REAL(wp), DIMENSION(1:3,1:4) ::  pm_frac_table = & !< rel. mass
+                                     RESHAPE( (/ 0.016_wp, 0.000_wp, 0.984_wp, &
+                                                 0.000_wp, 1.000_wp, 0.000_wp, &
+                                                 0.000_wp, 0.000_wp, 1.000_wp, &
+                                                 1.000_wp, 0.000_wp, 1.000_wp  &
+                                              /), (/3,4/) )
+
+    END TYPE salsa_emission_mode_type
+!
+!-- Aerosol emission data values
+    TYPE salsa_emission_value_type
+
+       REAL(wp) ::  fill  !< fill value
+
+       REAL(wp), DIMENSION(:), ALLOCATABLE :: preproc_mass_fracs  !< mass fractions
+
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE :: def_mass_fracs  !< mass fractions per emis. category
+
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: def_data      !< surface emission values in PM
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: preproc_data  !< surface emission values per bin
+
+    END TYPE salsa_emission_value_type
+!
+!-- Prognostic variable: Aerosol size bin information (number (#/m3) and mass (kg/m3) concentration)
+!-- and the concentration of gaseous tracers (#/m3). Gas tracers are contained sequentially in
+!-- dimension 4 as:
+!-- 1. H2SO4, 2. HNO3, 3. NH3, 4. OCNV (non-volatile organics), 5. OCSV (semi-volatile)
     TYPE salsa_variable
-       REAL(wp), POINTER, DIMENSION(:,:,:), CONTIGUOUS     ::  conc
-       REAL(wp), POINTER, DIMENSION(:,:,:), CONTIGUOUS     ::  conc_p
-       REAL(wp), POINTER, DIMENSION(:,:,:), CONTIGUOUS     ::  tconc_m
-       REAL(wp), ALLOCATABLE, DIMENSION(:,:)   ::  flux_s, diss_s
-       REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::  flux_l, diss_l
-       REAL(wp), ALLOCATABLE, DIMENSION(:)     ::  init
-       REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::  source
-       REAL(wp), ALLOCATABLE, DIMENSION(:,:)   ::  sums_ws_l
+
+       REAL(wp), ALLOCATABLE, DIMENSION(:)     ::  init  !<
+
+       REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::  diss_s     !<
+       REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::  flux_s     !<
+       REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::  source     !<
+       REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::  sums_ws_l  !<
+
+       REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::  diss_l  !<
+       REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::  flux_l  !<
+
+       REAL(wp), POINTER, DIMENSION(:,:,:), CONTIGUOUS ::  conc     !<
+       REAL(wp), POINTER, DIMENSION(:,:,:), CONTIGUOUS ::  conc_p   !<
+       REAL(wp), POINTER, DIMENSION(:,:,:), CONTIGUOUS ::  tconc_m  !<
+
     END TYPE salsa_variable
-    
-!-- Map bin indices between parallel size distributions    
-    TYPE t_parallelbin
-       INTEGER(iwp) ::  cur  ! Index for current distribution
-       INTEGER(iwp) ::  par  ! Index for corresponding parallel distribution
-    END TYPE t_parallelbin
-    
-!-- Datatype used to store information about the binned size distributions of 
-!-- aerosols
+!
+!-- Datatype used to store information about the binned size distributions of aerosols
     TYPE t_section
+
+       REAL(wp) ::  dmid     !< bin middle diameter (m)
        REAL(wp) ::  vhilim   !< bin volume at the high limit
        REAL(wp) ::  vlolim   !< bin volume at the low limit
        REAL(wp) ::  vratiohi !< volume ratio between the center and high limit
        REAL(wp) ::  vratiolo !< volume ratio between the center and low limit
-       REAL(wp) ::  dmid     !< bin middle diameter (m)
        !******************************************************
        ! ^ Do NOT change the stuff above after initialization !
        !******************************************************
+       REAL(wp) ::  core    !< Volume of dry particle
        REAL(wp) ::  dwet    !< Wet diameter or mean droplet diameter (m)
-       REAL(wp), DIMENSION(maxspec+1) ::  volc !< Volume concentrations 
-                            !< (m^3/m^3) of aerosols + water. Since most of 
-                            !< the stuff in SALSA is hard coded, these *have to
-                            !< be* in the order
-                            !< 1:SO4, 2:OC, 3:BC, 4:DU, 5:SS, 6:NO, 7:NH, 8:H2O
+       REAL(wp) ::  numc    !< Number concentration of particles/droplets (#/m3)
        REAL(wp) ::  veqh2o  !< Equilibrium H2O concentration for each particle
-       REAL(wp) ::  numc    !< Number concentration of particles/droplets (#/m3)
-       REAL(wp) ::  core    !< Volume of dry particle
-    END TYPE t_section  
-!
-!-- Local aerosol properties in SALSA 
-    TYPE(t_section), ALLOCATABLE ::  aero(:)
-!
-!-- SALSA tracers:
-!-- Tracers as x = x(k,j,i,bin). The 4th dimension contains all the size bins 
-!-- sequentially for each aerosol species  + water.
-!
-!-- Prognostic tracers:
-!
-!-- Number concentration (#/m3) 
-    TYPE(salsa_variable), ALLOCATABLE, DIMENSION(:), TARGET ::  aerosol_number
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  nconc_1
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  nconc_2
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  nconc_3
-!
-!-- Mass concentration (kg/m3) 
-    TYPE(salsa_variable), ALLOCATABLE, DIMENSION(:), TARGET ::  aerosol_mass
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  mconc_1
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  mconc_2
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  mconc_3
-!
-!-- Gaseous tracers (#/m3) 
-    TYPE(salsa_variable), ALLOCATABLE, DIMENSION(:), TARGET ::  salsa_gas
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  gconc_1
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  gconc_2
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  gconc_3
+
+       REAL(wp), DIMENSION(maxspec+1) ::  volc !< Volume concentrations (m^3/m^3) of aerosols +
+                                               !< water. Since most of the stuff in SALSA is hard
+                                               !< coded, these *have to be* in the order
+                                               !< 1:SO4, 2:OC, 3:BC, 4:DU, 5:SS, 6:NO, 7:NH, 8:H2O
+    END TYPE t_section
+
+    TYPE(salsa_emission_attribute_type) ::  aero_emission_att  !< emission attributes
+    TYPE(salsa_emission_value_type)     ::  aero_emission      !< emission values
+    TYPE(salsa_emission_mode_type)      ::  def_modes          !< default emission modes
+
+    TYPE(t_section), DIMENSION(:), ALLOCATABLE ::  aero  !< local aerosol properties
+
+    TYPE(match_lsm_depo) ::  lsm_to_depo_h
+
+    TYPE(match_lsm_depo), DIMENSION(0:3) ::  lsm_to_depo_v
+!
+!-- SALSA variables: as x = x(k,j,i,bin). 
+!-- The 4th dimension contains all the size bins sequentially for each aerosol species  + water.
+!
+!-- Prognostic variables:
+!
+!-- Number concentration (#/m3)
+    TYPE(salsa_variable), ALLOCATABLE, DIMENSION(:), TARGET ::  aerosol_number  !<
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  nconc_1  !<
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  nconc_2  !<
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  nconc_3  !<
+!
+!-- Mass concentration (kg/m3)
+    TYPE(salsa_variable), ALLOCATABLE, DIMENSION(:), TARGET ::  aerosol_mass  !<
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  mconc_1  !<
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  mconc_2  !<
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  mconc_3  !<
+!
+!-- Gaseous concentrations (#/m3)
+    TYPE(salsa_variable), ALLOCATABLE, DIMENSION(:), TARGET ::  salsa_gas  !<
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  gconc_1  !<
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  gconc_2  !<
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  gconc_3  !<
 !
 !-- Diagnostic tracers
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) ::  sedim_vd !< sedimentation
-                                                           !< velocity per size 
-                                                           !< bin (m/s)
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) ::  Ra_dry !< dry radius (m)
-    
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) ::  sedim_vd  !< sedimentation velocity per bin (m/s)
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) ::  ra_dry    !< aerosol dry radius (m)
+
 !-- Particle component index tables
-    TYPE(component_index) :: prtcl !< Contains "getIndex" which gives the index 
-                                   !< for a given aerosol component name, i.e. 
-                                   !< 1:SO4, 2:OC, 3:BC, 4:DU,
-                                   !< 5:SS, 6:NO, 7:NH, 8:H2O  
-!                                   
+    TYPE(component_index) :: prtcl  !< Contains "getIndex" which gives the index for a given aerosol
+                                    !< component name: 1:SO4, 2:OC, 3:BC, 4:DU, 5:SS, 6:NO, 7:NH, 8:H2O
+!
 !-- Data output arrays:
+!
 !-- Gases:
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  g_H2SO4_av  !< H2SO4
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  g_HNO3_av   !< HNO3
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  g_NH3_av    !< NH3
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  g_OCNV_av   !< non-vola-
-                                                                    !< tile OC
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  g_OCSV_av   !< semi-vol.
-                                                                    !< OC
-!-- Integrated:                                                                    
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  LDSA_av  !< lung-
-                                                                 !< deposited 
-                                                                 !< surface area                                                    
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  Ntot_av  !< total number
-                                                                 !< conc.
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  PM25_av  !< PM2.5
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  PM10_av  !< PM10
-!-- In the particle phase:    
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_BC_av  !< black carbon 
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_DU_av  !< dust 
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_H2O_av !< liquid water
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_NH_av  !< ammonia 
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_NO_av  !< nitrates 
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_OC_av  !< org. carbon 
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_SO4_av !< sulphates
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_SS_av  !< sea salt
-!-- Bins:    
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  mbins_av !< bin mass  
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  Nbins_av !< bin number 
-
-    
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  g_h2so4_av  !< H2SO4
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  g_hno3_av   !< HNO3
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  g_nh3_av    !< NH3
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  g_ocnv_av   !< non-volatile OC
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  g_ocsv_av   !< semi-volatile OC
+!
+!-- Integrated:
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  ldsa_av  !< lung-deposited surface area
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  ntot_av  !< total number concentration
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  pm25_av  !< PM2.5
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  pm10_av  !< PM10
+!
+!-- In the particle phase:
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_bc_av   !< black carbon
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_du_av   !< dust
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_h2o_av  !< liquid water
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_nh_av   !< ammonia
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_no_av   !< nitrates
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_oc_av   !< org. carbon
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_so4_av  !< sulphates
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_ss_av   !< sea salt
+!
+!-- Bin specific mass and number concentrations:
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  mbins_av  !< bin mas
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  nbins_av  !< bin number
+
 !
 !-- PALM interfaces:
